#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def cn(u0,L,k):
    s=np.linspace(0,L,1000)
    f=u0(s,L)*np.sin(k*np.pi*s/L)
    return np.trapz(f,s)*2/L

def cn_vec(u0,L,N):
    s=np.linspace(0,L,1000)
    f=np.zeros(N+1)
    for k in range(1,N+1):
        fk=u0(s,L)*np.sin(k*np.pi*s/L)
        f[k]=np.trapz(fk,s)*2/L
    return f

def fft_u0(u0,L,N):
    s=np.linspace(0,L,1000)
    f=u0(s,L)
    ft=np.fft.fft(f)
    return np.real(ft),np.imag(ft)

def sn(u0,L,D,N,x,t):
    s=0
    for k in range(1,N+1):
        s=s+cn(u0,L,k)*np.sin(k*np.pi*x/L)*np.exp(-D*t*(k*np.pi*L)**2)
    return s


def sn_vec(u0,L,D,N,x,t):
    s=0
    coef=cn_vec(u0,L,N)
    for k in range(1,N+1):
        s=s+coef[k]*np.sin(k*np.pi*x/L)*np.exp(-D*t*(k*np.pi*L)**2)
    return s

def sn_f(u0,L,D,N,x,t):
    s=0
    coef=fft_u0(u0,L,N)[1]
    for k in range(1,N+1):
        s=s+coef[k]*np.sin(k*np.pi*x/L)*np.exp(-D*t*(k*np.pi*L)**2)
    return s

def sn_fft(y,L,D,N,x,t):
    s=0
    for k in range(N+1):
        s=s+2*y[k]*np.sin(k*np.pi*x/L)*np.exp(-D*t*(k*np.pi*L)**2)/(N+1)
    return s

def cn_fft(y,L,D,N,x,t):
    s=0
    for k in range(N+1):
        s=s+2*y[k]*np.cos(k*np.pi*x/L)*np.exp(-D*t*(k*np.pi*L)**2)/(N+1)
    return s



def u1(x,L): 
    return 1

def uc(x,L):
    y=np.zeros(len(x))
    for i in range(len(x)):
        if x[i]<L/2:
            y[i]=1
    return y

def u2(x,L):
    return np.exp(-x**2/2/L)

def cr(x):
    if x<=0:
        return 1
    else:
        return 0
    
def po(x):
    if x>=0 and x<=1:
        return 1
    else:
        return 0
    


n=5
x=np.linspace(0,1,501)
L=1
D=2

plt.subplot(2,1,1)
for t in range(0,100,4):
    f=sn(u1,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
    
#plt.show()

plt.subplot(2,1,2)
for t in range(0,100,4):
    f1=sn_vec(u1,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f1)
    
plt.show()


xx=np.linspace(0,L,n+1)
#xx=2*np.pi/(n+1)*np.arange(n+1)
yy=np.ones(n+1)
yy[0]=0
yy[-1]=0
#u1(xx,L)
fy=np.fft.fft(yy)
sy=fy.imag
cy=fy.real

plt.subplot(3,1,1)
plt.plot(yy)

plt.subplot(3,1,2)
for t in range(0,100,4):
    f2=sn_fft(sy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie imaginaire')
    
#plt.show()
plt.subplot(3,1,3)


for t in range(0,100,4):
    f=sn(uc,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
    plt.ylabel('Partie reelle')
    
plt.show()

yy=uc(xx,L)
fy=np.fft.fft(yy)
sy=fy.imag
cy=fy.real

plt.subplot(3,1,1)
plt.plot(xx,yy)


plt.subplot(3,1,2)

for t in range(0,100,4):
    f2=sn_fft(sy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie imaginaire')
    
#plt.show()
plt.subplot(3,1,3)

for t in range(0,100,4):
    f2=sn_fft(cy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie reelle')


plt.show()

plt.subplot(3,1,1)

for t in range(0,100,4):
    f=sn(u2,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
    

#plt.show()



yy=u2(xx,L)
fy=np.fft.fft(yy)
sy=fy.imag
cy=fy.real

plt.subplot(3,1,2)

for t in range(0,100,4):
    f2=sn_fft(sy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie imaginaire')
    
plt.subplot(3,1,3)
for t in range(0,100,4):
    f3=sn_fft(cy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f3)
    plt.ylabel('Partie reelle')
    
plt.show()

    
x=np.linspace(-10,10,200)
y=np.zeros(len(x))
for i in range(len(x)):
    y[i]=cr(x[i])

plt.plot(x,y)
plt.show()

   
x=np.linspace(-10,10,200)
y=np.zeros(len(x))
for i in range(len(x)):
    y[i]=po(x[i])

plt.plot(x,y)
plt.show()


xx=np.linspace(-L,L,1001)
yy=np.zeros(len(xx))
for i in range(len(xx)):
    yy[i]=cr(xx[i])
#yy=cr(xx)
fy=np.fft.fft(yy)
sy=fy.imag
cy=fy.real

plt.subplot(3,1,1)
plt.plot(yy)
plt.ylabel('fonction creneau')


plt.subplot(3,1,2)

for t in range(0,100,4):
    f2=sn_fft(sy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie imaginaire')
   # plt.title('Fonction creneau')
    
plt.subplot(3,1,3)
for t in range(0,100,4):
    f3=sn_fft(cy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f3)
    plt.ylabel('Partie reelle')
    
plt.show()


xx=np.linspace(-L,L,1001)
yy=np.zeros(len(xx))
for i in range(len(xx)):
    yy[i]=po(2*xx[i])
#yy=cr(xx)
fy=np.fft.fft(yy)
sy=fy.imag
cy=fy.real

plt.subplot(3,1,1)
plt.plot(yy)
plt.ylabel('fonction porte')


plt.subplot(3,1,2)

for t in range(0,100,4):
    f2=sn_fft(sy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f2)
    plt.ylabel('Partie imaginaire')
    #plt.title('Fonction porte')
    
plt.subplot(3,1,3)
for t in range(0,100,4):
    f3=sn_fft(cy,L,D,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f3)
    plt.ylabel('Partie reelle')
    
plt.show()
