#Dans Terminal:
#jupyter lab
#python tp1.py


import matplotlib.pyplot as plt
import numpy as np

def cn(u0,k):
    s=np.linspace(0,1,1000)
    f=u0(s)*np.sin(k*np.pi*s)
    return 2*np.trapz(f,s)

def sn(u0,N,x,t):
    s=0
    for k in range(1,N+1):
        s=s+cn(u0,k)*np.sin(k*np.pi*x)*np.exp(-t*(k*np.pi)**2)
    return s



def u1(x):
    if x==0:
        return 0
    else:
        if x==1: 
            return 0
        else:
            return 1
    #return 1
    
def u1_vec(x):
    u=np.zeros(len(x))
    for i in range(len(x)):
        u[i]=u1(x[i])
    return u
        

def u2(x):
    return x*(1-x)

def u3(x):
    return np.sin(np.pi*x)

def u4(x):
    return np.cos(np.pi*(x+0.5))


def lap(n):
    return 2*np.diag(np.ones(n))-np.diag(np.ones(n-1),-1)-np.diag(np.ones(n-1),+1)

def un(h,alpha,f,n,u):
    return np.dot(np.eye(n)-alpha*lap(n),u)+h*f


n=5
x=np.linspace(0,1,501)




for t in range(0,100,4):
    f=sn(u1_vec,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
    
plt.title('Fourier Avec u1')
    
plt.show()




xx=np.linspace(0,1,n+1)
xx.shape=(n+1,1)
f=np.zeros((n+1,1))

u=u1_vec(xx)
#np.ones((n+1,1)) #u0(x)
hx=1/(n+1)
#ht=alpha*hx*hx
ht=0.004
alpha=ht*(n+1)*(n+1)
#f[0]=alpha
#f[-1]=alpha


plt.plot(xx,u)

for t in range(0,100,4):
    u=un(ht,alpha,f,n+1,u)
    u[0]=0
    u[-1]=0
    plt.plot(xx,u)
  
plt.title('EF Avec u1')
plt.show()


######### Avec u2: #######
n=10 #5
x=np.linspace(0,1,501)


for t in range(0,100,4):
    f=sn(u2,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
    plt.title('Fourier Avec u2')
    
plt.show()


n=10

xx=np.linspace(0,1,n+1)
xx.shape=(n+1,1)
f=np.zeros((n+1,1))

u=u2(xx)
hx=1/(n+1)
#ht=alpha*hx*hx
ht=0.004
alpha=ht*(n+1)*(n+1)
#f[0]=alpha
#f[-1]=alpha


plt.plot(xx,u)

for t in range(0,100,4):
    u=un(ht,alpha,f,n+1,u)
    u[0]=0
    u[-1]=0
    plt.plot(xx,u)

plt.title('EF Avec u2')
plt.show()


######### Avec u3: #######
n=5
x=np.linspace(0,1,501)


for t in range(0,100,4):
    f=sn(u3,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)
plt.title('Fourier Avec u3')
plt.show()


n=5

xx=np.linspace(0,1,n+1)
xx.shape=(n+1,1)
f=np.zeros((n+1,1))

u=u3(xx)
hx=1/(n+1)
#ht=alpha*hx*hx
ht=0.004
alpha=ht*(n+1)*(n+1)
#f[0]=alpha
#f[-1]=alpha


plt.plot(xx,u)

for t in range(0,100,4):
    u=un(ht,alpha,f,n+1,u)
    u[0]=0
    u[-1]=0
    plt.plot(xx,u)

plt.title('EF Avec u3')
plt.show()


######### Avec u4: #######
n=5
x=np.linspace(0,1,501)


for t in range(0,100,4):
    f=sn(u4,n,x,t/1000)
    #print(f.shape)
    plt.plot(x,f)

plt.title('Fourier Avec u4')
plt.show()


n=5

xx=np.linspace(0,1,n+1)
xx.shape=(n+1,1)
f=np.zeros((n+1,1))

u=u4(xx)
hx=1/(n+1)
#ht=alpha*hx*hx
ht=0.004
alpha=ht*(n+1)*(n+1)
print('alpha=',alpha)
#f[0]=alpha
#f[-1]=alpha


plt.plot(xx,u)

for t in range(0,100,4):
    u=un(ht,alpha,f,n+1,u)
    u[0]=0
    u[-1]=0
    plt.plot(xx,u)

plt.title('EF Avec u4')
plt.show()






